xmonad-contrib-0.16: Third party extensions for xmonad

Copyright | (c) Brent Yorgey 2009
License | BSD-style (see LICENSE)
Maintainer | <byorgey@gmail.com>
Stability | experimental
Portability | unportable
Safe Haskell | None
Language | Haskell98

XMonad.Actions.DynamicWorkspaceGroups

Contents

- Usage

Description

Dynamically manage "workspace groups", sets of workspaces being used together for some common task or purpose, to allow switching between workspace groups in a single action. Note that this only makes sense for multi-head setups.

Synopsis

- type WSGroupId = String
- addRawWSGroup :: WSGroupId -> [(ScreenId, WorkspaceId)] -> X ()
- addWSGroup :: WSGroupId -> [WorkspaceId] -> X ()
- addCurrentWSGroup :: WSGroupId -> X ()
- forgetWSGroup :: WSGroupId -> X ()
- viewWSGroup :: WSGroupId -> X ()
- promptWSGroupView :: XPConfig -> String -> X ()
- promptWSGroupAdd :: XPConfig -> String -> X ()
- promptWSGroupForget :: XPConfig -> String -> X ()
- data WSGPrompt

# Usage

You can use this module by importing it into your ~/.xmonad/xmonad.hs file:

    import XMonad.Actions.DynamicWorkspaceGroups

Then add keybindings like the following (this example uses XMonad.Util.EZConfig-style keybindings, but this is not necessary):

       , ("M-y n", promptWSGroupAdd myXPConfig "Name this group: ")
       , ("M-y g", promptWSGroupView myXPConfig "Go to group: ")
       , ("M-y d", promptWSGroupForget myXPConfig "Forget group: ")

type WSGroupId = String Source #

addRawWSGroup :: WSGroupId -> [(ScreenId, WorkspaceId)] -> X () Source #

Add a new workspace group of the given name, mapping to an explicitly specified association between screen IDs and workspace names. This function could be useful for, say, creating some standard workspace groups in your startup hook.

addWSGroup :: WSGroupId -> [WorkspaceId] -> X () Source #

Add a new workspace group with the given name.

addCurrentWSGroup :: WSGroupId -> X () Source #

Give a name to the current workspace group.

forgetWSGroup :: WSGroupId -> X () Source #

Delete the named workspace group from the list of workspace groups. Note that this has no effect on the workspaces involved; it simply forgets the given name.

viewWSGroup :: WSGroupId -> X () Source #

View the workspace group with the given name.

promptWSGroupView :: XPConfig -> String -> X () Source #

Prompt for a workspace group to view.

promptWSGroupAdd :: XPConfig -> String -> X () Source #

Prompt for a name for the current workspace group.

promptWSGroupForget :: XPConfig -> String -> X () Source #

Prompt for a workspace group to forget.

data WSGPrompt Source #

#### Instances

Instances details

XPrompt WSGPrompt Source # |

Instance details

Defined in XMonad.Actions.DynamicWorkspaceGroups

Methods

showXPrompt :: WSGPrompt -> String Source #

nextCompletion :: WSGPrompt -> String -> [String] -> String Source #

commandToComplete :: WSGPrompt -> String -> String Source #

completionToCommand :: WSGPrompt -> String -> String Source #

completionFunction :: WSGPrompt -> ComplFunction Source #

modeAction :: WSGPrompt -> String -> String -> X () Source #